#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
using namespace std;

struct Input{
    vector<double> numbers;
    size_t bin_count{};
    size_t font_size{};
};
Input
input_data()
{
    Input in;
    size_t number_count;
    cin >> number_count;
    in.numbers.resize(number_count);

    vector<double> numbers(number_count);
    for (size_t i=0; i< number_count; i++) {
        cin >> in.numbers[i];
    }
    cin >> in.bin_count;

    size_t font_size_input = 0;
    while (font_size_input < 8 || font_size_input > 32) {
        cerr << "Enter font size (832, default is 12): ";
        cin >> font_size_input;
        cerr << "Invalid font size. Must be between 8 and 32.\n";
    }
    in.font_size = font_size_input;

    return in;
}

int main()
{
    size_t max_count;
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins, in.font_size);
}
